/* global top, WE, treeData, container,drawTree,startTree,node*/

/**
 * webEdition SDK
 *
 * webEdition CMS
 * $Rev: 14682 $
 * $Author: lukasimhof $
 * $Date: 2017-12-15 12:11:37 +0100 (Fri, 15 Dec 2017) $
 *
 * This source is part of the webEdition SDK. The webEdition SDK is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU Lesser General Public License can be found at
 * http://www.gnu.org/licenses/lgpl-3.0.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionSDK/License.txt
 *
 *
 * @category   we
 * @package    we_ui
 * @subpackage we_ui_controls
 * @license    http://www.gnu.org/licenses/lgpl-3.0.html  LGPL
 */
'use strict';

container.prototype.openClose = function (id) {
	var sort = "";
	if (id === "") {
		return;
	}
	var eintragsIndex = treeData.indexOfEntry(id);
	var openstatus;

	openstatus = (treeData[eintragsIndex].open ? 0 : 1);
	treeData[eintragsIndex].open = openstatus;

	if (openstatus && !treeData[eintragsIndex].loaded) {
		top.content.cmd.location = top.getFrameset() + "&pnt=cmd&pid=" + id + (sort !== "" ? "&sort=" + sort : "");
	} else {
		drawTree();
	}
	if (openstatus) {
		treeData[eintragsIndex].loaded = true;
	}
};

function reloadGroup(pid, offset) {
	var it = treeData.get(pid);
	if (it) {
		var openFolders = getOpenFoleders(pid);
		it.clear();
		startTree(pid, (offset ? offset : 0), openFolders);
	}
}

function getOpenFoleders(pid){
	pid = parseInt(pid);
	var index = treeData.indexOfEntry(pid);

	if(index !== -1){
		var openForlders = [];
		var parentPath = pid !== 0 ? treeData[index].path : '/';

		for (var i = 1; i <= treeData.len; i++) {
			if(parseInt(treeData[i].id) !== 0 
					&& parseInt(treeData[i].id) !== pid 
					&& treeData[i].path // newly added folders have no path property yet
					&& treeData[i].path.indexOf(parentPath) === 0 
					&& treeData[i].open === 1) {
				openForlders.push(treeData[i].id);
			}
		}

		return openForlders;
	}

	return [];
}

Node.prototype.showSegment = function () {
	reloadGroup(this.parentid, this.offset);
};

function info(text) {
	var i = top.content.document.getElementById("infoField");
	var s = top.content.document.getElementById("search");
	if (text !== " ") {
		s.style.display = "none";
		i.style.display = "block";
		i.innerHTML = text;
	} else {
		i.innerHTML = text;
		i.style.display = "none";
		s.style.display = "block";
	}
}

container.prototype.addSort = function (object) {
	this.len++;
	for (var i = this.len; i > 0; i--) {
		if (i > 1 && (this[i - 1].order > object.order)) {
			this[i] = this[i - 1];
			continue;
		}
		for (var j = i; j > 0; j--) {
			if (j > 1 && (this[j - 1].order == object.order) && (this[j - 1].text.toLowerCase() > object.text.toLowerCase() || (this[j - 1].typ > object.typ))) {
				this[j] = this[j - 1];
			} else {
				this[j] = object;
				break;
			}
		}
		break;
	}
};

function doClick(id, typ) {
	var node = treeData.get(id);
	top.content.editor.edbody.we_cmd("module_navigation_edit", node.id);
}
