/* global WE, top */

/**
 * webEdition CMS
 *
 * $Rev: 15026 $
 * $Author: lukasimhof $
 * $Date: 2018-03-10 00:10:01 +0100 (Sat, 10 Mar 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package    webEdition_base
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';

var wizzard = WE().util.getDynamicVar(document, 'loadVarEIWizard', 'data-wizzard');
var table = WE().consts.tables.FILE_TABLE;
var type, selection, export_to;


function doUnload() {
	WE().util.jsWindow.prototype.closeAll(window);
}

function doNextAction() {
	top.edbody.document.we_form.step.value++;
	top.footer.location = WE().consts.dirs.WEBEDITION_DIR + "we_showMod.php?mod=customer&pnt=eifooter&art=import&step=" + top.edbody.document.we_form.step.value;
	if (parseInt(top.edbody.document.we_form.step.value) > 4) {
		top.edbody.document.we_form.target = "load";
		top.edbody.document.we_form.pnt.value = "eiload";
	}
	top.edbody.document.we_form.submit();
}

function selectWeSelect_doOnselect(sel) {
	sel.form.elements.xml_to.value = sel.options[sel.selectedIndex].value;
	sel.form.elements.xml_from.value = 1;
	sel.form.elements.dataset.value = sel.options[sel.selectedIndex].text;
	if (sel.options[sel.selectedIndex].value == 1) {
		sel.form.elements.xml_from.disabled = true;
		sel.form.elements.xml_to.disabled = true;
	} else {
		sel.form.elements.xml_from.disabled = false;
		sel.form.elements.xml_to.disabled = false;
	}
}

function we_cmd() {
	/*jshint validthis:true */
	var caller = (this && this.window === this ? this : window);
	var args = WE().util.getWe_cmdArgsArray(Array.prototype.slice.call(arguments));
	var url = WE().util.getWe_cmdArgsUrl(args);
	var arg = args[1]; // we use this when using named params

	switch (args[0]) {
		case "setProgress":
			top.footer.setProgress(args[1]);
			break;
		case "fileupload_startImport":
			//we_cmd('set_radio_importFrom', '', 1);
			doNextAction();
			break;
		case "uploader_cancel":
			top.edbody.weFileUpload_instance.cancelUpload();
			break;
		case "set_radio_importFrom":
			top.edbody.document.we_form.import_from[args[2]].checked = true;
			break;
		case "set_topVar":
			top[arg.name] = arg.fromInput ? top.edbody.document.we_form.elements[arg.name].value : arg.value;
			break;
		case "set_formField":
			top.edbody.document.we_form.elements[arg.name].value = arg.value;
			break;
		case "selectCharset_onchange":
			top.edbody.document.we_form.elements.the_charset.value = arg.select.options[arg.select.selectedIndex].value;
			arg.select.selectedIndex = -1;
			break;
		case "chooser_onChange":
			top.edbody.document.we_form.elements[args[2]].value = args[1].options[args[1].selectedIndex].value;
			args[1].selectedIndex = 0;
			break;
		case "we_selector_file":
			new (WE().util.jsWindow)(caller, url, "we_selector", WE().consts.size.dialog.big, WE().consts.size.dialog.medium, true, true, true, true);
			break;
		case "add_customer":
			top.edbody.document.we_form.selection[2].checked = true;
			top.edbody.document.we_form.wcmd.value = args[0];
			top.edbody.document.we_form.cus.value = args[1].allIDs.join(',');
			top.edbody.document.we_form.submit();
			break;
		case "del_customer":
		case "del_all_customers":
			top.edbody.document.we_form.selection[2].checked = true;
			top.edbody.document.we_form.wcmd.value = args[0];
			top.edbody.document.we_form.cus.value = args[1];
			top.edbody.document.we_form.submit();
			break;
		case "do_back":
			we_cmd('load_processCmd', 'export_back', args[1]);
			break;
		case "reload_frame":
			top.frames[arg.frame].location = WE().consts.dirs.WEBEDITION_DIR + 'we_showMod.php?mod=customer&pnt=' + arg.pnt + '&art=' + arg.art + '&cmd=' + arg.cmd + '&step=' + arg.step;
			break;
		case "process_cmd_load":
			top.load.location = WE().consts.dirs.WEBEDITION_DIR + 'we_cmd.php?we_cmd[0]=loadTree&we_cmd[1]=' + args[1] + '&we_cmd[2]=' + args[2] + '&we_cmd[3]=' + args[3];
			break;
		case "load_processCmd":
			switch (arg.cmd) {
				case 'export_next':
					top.edbody.document.we_form.step.value++;
					top.footer.location = WE().consts.dirs.WEBEDITION_DIR + "we_showMod.php?mod=customer&pnt=eifooter&art=" + arg.art + "&step=" + top.edbody.document.we_form.step.value;
					if (top.edbody.document.we_form.step.value > 3) {
						top.edbody.document.we_form.target = "load";
						top.edbody.document.we_form.pnt.value = "eiload";
						top.edbody.document.we_form.cmd.value = wizzard.art;
					}
					top.edbody.document.we_form.submit();
					break;
				case 'export_back':
					top.edbody.document.we_form.step.value--;
					top.footer.location = WE().consts.dirs.WEBEDITION_DIR + "we_showMod.php?mod=customer&pnt=eifooter&art=" + arg.art + "&step=" + top.edbody.document.we_form.step.value;
					top.edbody.document.we_form.submit();
					break;
				case 'import':
					top.step++;
					top.load.document.we_form.submit();
					break;
				case 'import_next':
					if (parseInt(top.edbody.document.we_form.step.value) === 2 &&
									top.edbody.weFileUpload_instance !== undefined &&
									top.edbody.document.we_form.import_from[1].checked) {
						top.edbody.weFileUpload_instance.checkStartUpload('fileupload_startImport');
						break;
					}
					doNextAction();
					break;
				case 'import_back':
					top.edbody.document.we_form.step.value--;
					top.footer.location = WE().consts.dirs.WEBEDITION_DIR + "we_showMod.php?mod=customer&pnt=eifooter&art=" + arg.art + "&step=" + top.edbody.document.we_form.step.value;
					top.edbody.document.we_form.submit();
					break;
				case 'do_import':
					if ((arg.fstart < arg.fcount)) {
						top.load.document.we_form.cmd.value = 'do_import';
					} else {
						top.load.document.we_form.cmd.value = 'import_end';
					}
					if (top.footer.setProgress) {
						top.footer.setProgress(arg.percent);
					}
					top.load.document.we_form.submit();
					break;
				case 'import_end':
					if (top.opener && top.opener.content && top.opener.top.content.applySort) {
						top.opener.top.content.applySort();
					}
					top.footer.location = WE().consts.dirs.WEBEDITION_DIR + 'we_showMod.php?mod=customer&pnt=eifooter&art=' + arg.art + '&step=6';
					top.load.document.we_form.submit();
					break;
			}
			break;
		case "setHot":
			// prevent call from bubbling up
			break;
		case "change_filter":
			switch (args[1]) {
				case "add_filter":
				case "del_filter":
				case "del_all_filters":
					top.edbody.document.we_form.selection[1].checked = true;
					top.edbody.document.we_form.fcmd.value = args[1];
					top.edbody.document.we_form.submit();
					break;
			}
			break;
		default:
			top.opener.we_cmd.apply(caller, Array.prototype.slice.call(arguments));
	}
}