<?php
/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */

/**
 * LiveUpdateTemplates is a helper function taking care of the view of the
 * update process. The functions here are only called from templates!
 *
 */
class liveUpdateTemplates{

	/**
	 * returns standard html container for output
	 *
	 * @param string $headline
	 * @param string $content
	 * @param integer $width
	 * @param integer $height
	 * @return string
	 */
	static function getContainer($headline, $content, $buttons = ''){
		return we_html_element::div(['id' => 'contentDiv'], we_html_element::div(['id' => "contentHeadlineDiv"], '<b>' . $headline . '</b><hr />') .
				we_html_element::div(['id' => "contentTextDiv"], $content) .
				($buttons ? we_html_element::div(['id' => "buttonDiv"], $buttons) : '')
		);
	}

	/**
	 * returns header of template
	 *
	 * @return string
	 */
	static function getHtmlHead(){
		return we_html_tools::metaCtCharset($GLOBALS['we']['Charset']['Backend']) . LIVEUPDATE_CSS;
	}

	/**
	 * Returns a html page as response
	 *
	 * @param string $headline
	 * @param string $content
	 * @param string $header
	 * @param string $buttons
	 * @param integer $contentWidth
	 * @param integer $contentHeight
	 * @return string
	 */
	static function getHtml($headline, $content, $header = '', $buttons = '', $contentWidth = 550, $contentHeight = 400){
		return we_html_tools::getHtmlTop('', '', '', liveUpdateTemplates::getHtmlHead() .
				$header, '<body>' .
				self::getContainer($headline, $content, $buttons) .
				'</body>');
	}

}
