<?php
/**
 * webEdition CMS
 *
 * $Rev: 14885 $
 * $Author: mokraemer $
 * $Date: 2018-02-12 14:22:05 +0100 (Mon, 12 Feb 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
require_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we.inc.php');
we_html_tools::protect();

$protocol = 'json';

function dieWithError($text, $protocol){
	switch($protocol){
		case 'json':
			$resp = new we_rpc_response();
			$resp->setStatus(false);
			$resp->setData('data', $text);
			$errorView = new we_rpc_genericJSONView('', $protocol);
			echo $errorView->getResponse($resp);
			exit;
		default:
			exit($text);
	}
}

if(!we_base_request::_(we_base_request::STRING, 'cmd')){
	dieWithError('The Request is not well formed!', $protocol);
}

$shell = new we_rpc_cmdShell($protocol);

if($shell->getStatus() == we_rpc_cmd::STATUS_OK){
	$shell->executeCommand();
	echo $shell->getResponse();
	session_write_close();
	flush();
	if(function_exists('fastcgi_finish_request')){
		fastcgi_finish_request();
	}
	ignore_user_abort(true);
	$shell->cleanUp();
} else { // there was an error in initializing the command
	dieWithError($shell->getErrorOut(), $protocol);
}

unset($shell);
