<?php
/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
return [
	'new' => [
		'text' => g_l('navigation', '[menu_new]'),
		'icon' => 'fa fa-plus-circle',
	],
	['text' => g_l('navigation', '[entry]'),
		'parent' => 'new',
		'cmd' => 'module_navigation_new',
		'perm' => [we_base_perm::NAVIGATION_EDIT],
	],
	['text' => g_l('navigation', '[group]'),
		'parent' => 'new',
		'cmd' => 'module_navigation_new_group',
		'perm' => [we_base_perm::NAVIGATION_EDIT],
	],
	'navigation' => [
		'text' => g_l('navigation', '[navigation]'),
		'icon' => 'fa fa-compass',
	],
	['text' => g_l('navigation', '[menu_save]'),
		'parent' => 'navigation',
		'cmd' => 'module_navigation_save',
		'perm' => [we_base_perm::NAVIGATION_EDIT],
	],
	['text' => g_l('navigation', '[menu_delete]'),
		'parent' => 'navigation',
		'cmd' => 'module_navigation_delete',
		'perm' => [we_base_perm::NAVIGATION_DELETE, we_base_perm::NAVIGATION_EDIT],
	],
	['parent' => 'navigation',],
	['text' => g_l('navigation', '[menu_exit]'),
		'parent' => 'navigation',
		'cmd' => 'exit_navigation',
	],
	'options' => [
		'text' => g_l('navigation', '[menu_options]'),
		'perm' => [we_base_perm::NAVIAGTION_EDIT_RULES],
		'icon' => 'fa fa-cog'
	],
	['text' => g_l('navigation', '[menu_highlight_rules]'),
		'parent' => 'options',
		'perm' => [we_base_perm::NAVIAGTION_EDIT_RULES],
		'cmd' => 'module_navigation_rules',
	],
	['text' => g_l('navigation', '[reset_customer_filter]'),
		'parent' => 'options',
		'perm' => [we_base_perm::ADMINISTRATOR],
		'cmd' => 'module_navigation_reset_customer_filter',
		'hide' => !we_modules_info::isActive(we_modules_info::CUSTOMER)
	],
];
