<?php
/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
return [
	'new' => [
		'text' => g_l('menu_users', '[menu_new]'),
		'icon' => 'fa fa-plus-circle',
	],
	['text' => g_l('menu_users', '[menu_user]'),
		'parent' => 'new',
		'cmd' => 'new_user',
		'perm' => [we_base_perm::USER_NEW],
	],
	['text' => g_l('menu_users', '[menu_alias]'),
		'parent' => 'new',
		'cmd' => 'new_alias',
		'perm' => [we_base_perm::USER_NEW],
	],
	['parent' => 'new',],
	['text' => g_l('menu_users', '[group]'),
		'parent' => 'new',
		'cmd' => 'new_group',
		'perm' => [we_base_perm::USER_GROUP_NEW],
	],
	'user' => [
		'text' => g_l('menu_users', '[menu_user]'),
		'icon' => 'fa fa-user'
	],
	['text' => g_l('menu_users', '[menu_save]'),
		'parent' => 'user',
		'cmd' => 'save_user',
		'perm' => [we_base_perm::USER_GROUP_NEW, we_base_perm::USER_NEW, we_base_perm::USER_SAVE, we_base_perm::USER_GROUP_SAVE],
	],
	['text' => g_l('menu_users', '[menu_delete]'),
		'parent' => 'user',
		'cmd' => 'delete_user',
		'perm' => [we_base_perm::USER_DELETE, we_base_perm::USER_GROUP_DELETE],
	],
	['parent' => 'user',],
	['text' => g_l('menu_users', '[menu_exit]'),
		'parent' => 'user',
		'cmd' => 'exit_users',
	],
];
