<?php
/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
return [
	'new' => [
		'text' => g_l('menu_workflow', '[new]'),
		'perm' => [we_base_perm::WORKFLOW_NEW],
		'icon' => 'fa fa-plus-circle',
	],
	['text' => g_l('menu_workflow', '[new]'),
		'cmd' => 'new_workflow',
		'perm' => [we_base_perm::WORKFLOW_NEW],
		'parent' => 'new',
	],
	'workflow' => [
		'text' => g_l('menu_workflow', '[workflow]'),
		'icon' => 'fa fa-gears'
	],
	['text' => g_l('menu_workflow', '[save]'),
		'parent' => 'workflow',
		'cmd' => 'save_workflow',
		'perm' => [we_base_perm::WORKFLOW_EDIT],
	],
	['text' => g_l('menu_workflow', '[delete]'),
		'parent' => 'workflow',
		'cmd' => 'delete_workflow',
		'perm' => [we_base_perm::WORKFLOW_DELETE],
	],
	['parent' => 'workflow',],
	/*
	  [
	  'text'=> g_l('menu_workflow','[reload]'),
	  'parent'=> 'workflow',
	  'cmd'=> 'reload_workflow',
	  'enabled'=> '0',
	  ],
	  $we_menu_workflow['000880']['parent'] = 'workflow'; // separator
	 */
	['text' => g_l('menu_workflow', '[empty_log]') . '&hellip;',
		'parent' => 'workflow',
		'cmd' => 'empty_log',
		'perm' => [we_base_perm::WORKFLOW_EMPTY_LOG],
	],
	['parent' => 'workflow',],
	['text' => g_l('menu_workflow', '[quit]'),
		'parent' => 'workflow',
		'cmd' => 'exit_workflow',
	],
];
