<?php

/**
 * //NOTE you are inside the constructor of we_tagData_base.class.php
 * webEdition CMS
 *
 * $Rev: 14852 $
 * $Author: mokraemer $
 * $Date: 2018-02-07 21:27:52 +0100 (Wed, 07 Feb 2018) $
 */
$this->NeedsEndTag = false;
$this->Module = we_modules_info::CUSTOMER;
$this->Description = g_l('weTag', '[' . $tagName . '][description]', true);

$name = new we_tagData_textAttribute('name', true, '');
$property = new we_tagData_selectAttribute('property', we_tagData_selectAttribute::getTrueFalse());
$checked = new we_tagData_selectAttribute('checked', we_tagData_selectAttribute::getTrueFalse());
$editable = new we_tagData_selectAttribute('editable', we_tagData_selectAttribute::getTrueFalse());
$xml = new we_tagData_selectAttribute('xml', we_tagData_selectAttribute::getTrueFalse());
$removefirstparagraph = new we_tagData_selectAttribute('removefirstparagraph', we_tagData_selectAttribute::getTrueFalse());
$size = new we_tagData_textAttribute('size');
$maxlength = new we_tagData_textAttribute('maxlength');
$format = new we_tagData_textAttribute('format');
$value = new we_tagData_textAttribute('value');
$values = new we_tagData_textAttribute('values');
$hidden = new we_tagData_selectAttribute('hidden', we_tagData_selectAttribute::getTrueFalse());
$currentdate = new we_tagData_selectAttribute('currentdate', we_tagData_selectAttribute::getTrueFalse());
$cols = new we_tagData_textAttribute('cols');
$rows = new we_tagData_textAttribute('rows');
$pure = new we_tagData_selectAttribute('pure', we_tagData_selectAttribute::getTrueFalse());
//$autobr = new we_tagData_selectAttribute('autobr', we_tagData_selectAttribute::getTrueFalse());
$width = new we_tagData_textAttribute('width');
$height = new we_tagData_textAttribute('height');
$bgcolor = new we_tagData_textAttribute('bgcolor');
$class = new we_tagData_textAttribute('class');
$style = new we_tagData_textAttribute('style');
$classes = new we_tagData_textAttribute('classes');
$wysiwyg = new we_tagData_selectAttribute('wysiwyg', we_tagData_selectAttribute::getTrueFalse());
$buttonpos = new we_tagData_choiceAttribute('buttonpos', [new we_tagData_option('top'), new we_tagData_option('bottom')], false, false, '');
$commands = new we_tagData_choiceAttribute('commands', we_wysiwyg_editor::getEditorCommands(true), false, true, '');
$contextmenu = new we_tagData_choiceAttribute('contextmenu', we_wysiwyg_editor::getEditorCommands(true), false, true, '');
$editorcss = new we_tagData_selectorAttribute('editorcss', FILE_TABLE, we_base_ContentTypes::CSS, false, '');
$ignoredocumentcss = new we_tagData_selectAttribute('ignoredocumentcss', we_tagData_selectAttribute::getTrueFalse());
$fontnames = new we_tagData_choiceAttribute('fontnames', [new we_tagData_option('arial'),
	new we_tagData_option('courier'),
	new we_tagData_option('tahoma'),
	new we_tagData_option('times'),
	new we_tagData_option('verdana'),
	new we_tagData_option('wingdings'),
		], false, true, '');
$parentid = new we_tagData_selectorAttribute('parentid', FILE_TABLE, we_tagData_selectorAttribute::FOLDER, true);
$quality = new we_tagData_selectAttribute('quality', [new we_tagData_option('0'),
	new we_tagData_option('1'),
	new we_tagData_option('2'),
	new we_tagData_option('3'),
	new we_tagData_option('4'),
	new we_tagData_option('5'),
	new we_tagData_option('6'),
	new we_tagData_option('7'),
	new we_tagData_option('8'),
	new we_tagData_option('9'),
	new we_tagData_option('10'),
		]);
$keepratio = new we_tagData_selectAttribute('keepratio', we_tagData_selectAttribute::getTrueFalse());
$maximize = new we_tagData_selectAttribute('maximize', we_tagData_selectAttribute::getTrueFalse());
$bordercolor = new we_tagData_textAttribute('bordercolor');
$checkboxstyle = new we_tagData_textAttribute('checkboxstyle');
$checkboxclass = new we_tagData_textAttribute('checkboxclass');
$inputstyle = new we_tagData_textAttribute('inputstyle');
$inputclass = new we_tagData_textAttribute('inputclass');
$checkboxtext = new we_tagData_textAttribute('checkboxtext');
$doc = new we_tagData_selectAttribute('doc', [
	new we_tagData_option('self'),
	new we_tagData_option('top'),
		], false, '');
$minyear = new we_tagData_textAttribute('minyear');
$maxyear = new we_tagData_textAttribute('maxyear');
/* $thumbnail = new we_tagData_sqlRowAttribute('thumbnail', THUMBNAILS_TABLE, false, 'Text', '', '', '');
  $thumbid = new we_tagData_sqlRowAttribute('thumbnailid', THUMBNAILS_TABLE, false, 'ID', 'Text', 'Text');
 */

$this->TypeAttribute = new we_tagData_typeAttribute('type', [
	new we_tagData_option('textinput', false, '', [$name, $property, $editable, $size, $maxlength, $value,
		$class, $style], [$name]),
	new we_tagData_option('textarea', false, '', [$name, $property, $editable, $value, $cols, $rows, /* $autobr, */ $width, $height, $bgcolor, $class, $style, /* $hideautobr, */
		$wysiwyg, $wysiwyg, $buttonpos, $ignoredocumentcss, $editorcss, $commands, $contextmenu, $fontnames, $classes], [$name]),
	new we_tagData_option('checkbox', false, '', [$name, $property, $checked, $editable], [$name]),
	new we_tagData_option('radio', false, '', [$name, $property, $checked, $editable, $value], [$name]),
	new we_tagData_option('choice', false, '', [$name, $property, $editable, $size, $maxlength, $value, $values, $class, $style], [$name]),
	new we_tagData_option('select', false, '', [$name, $property, $editable, $size, $value, $values, $class, $style], [$name]),
	new we_tagData_option('hidden', false, '', [$name, $property, $value], [$name]),
	new we_tagData_option('print', false, '', [$name, $property], [$name]),
	new we_tagData_option('date', false, '', [$name, $property, $editable, $currentdate, $format, $value, $minyear, $maxyear, $hidden], [$name]),
	new we_tagData_option('password', false, '', [[]]),
	new we_tagData_option('img', false, '', [$name, $editable, $size, $value, $width, $height, /* $thumbnail, $thumbid, */ $parentid, $quality, $keepratio, $maximize,
		$bordercolor,
		$checkboxstyle, $checkboxclass, $inputstyle, $inputclass, $checkboxtext], [$name, $parentid]),
	new we_tagData_option('flashmovie', false, '', [$name, $editable, $size, $value, $width, $height, $parentid, $quality, $keepratio, $maximize, $bordercolor,
		$checkboxstyle, $checkboxclass, $inputstyle, $inputclass, $checkboxtext], [$name, $parentid]),
	new we_tagData_option('binary', false, '', [$name, $editable, $size, $value, $parentid, $bordercolor, $checkboxstyle, $checkboxclass, $inputstyle, $inputclass,
		$checkboxtext], [$name, $parentid]),
	new we_tagData_option('country', false, '', [$name, $size, $class, $style, $doc, $value], [$name]),
	new we_tagData_option('language', false, '', [$name, $size, $class, $style, $doc, $value], [$name])], true, '');

$this->Attributes = [$name, $property, $checked, $editable, $xml, $removefirstparagraph, $size, $maxlength, $format, $value, $values, $hidden, $currentdate, $cols,
	$rows, $pure, /* $autobr, */ $width, $height, $bgcolor, $class, $style, $wysiwyg, $buttonpos, $ignoredocumentcss, $editorcss, $commands, $contextmenu, $classes,
	$fontnames,
	$parentid, $quality, $keepratio, $maximize, /* $thumbnail, $thumbid, */ $bordercolor,
	$checkboxstyle, $checkboxclass, $inputstyle, $inputclass, $checkboxtext, $doc, $minyear, $maxyear];
