<?php

/**
 * webEdition CMS
 *
 * $Rev: 14863 $
 * $Author: mokraemer $
 * $Date: 2018-02-10 02:45:17 +0100 (Sat, 10 Feb 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_cache_file implements we_cache_base{

	public static function load($entry){
		$file = WE_CACHE_PATH . 'we_cache_' . $entry;
		return !file_exists($file) ||
			f('SELECT 1 FROM ' . CLEAN_UP_TABLE . ' WHERE Path="' . $GLOBALS['DB_WE']->escape(WE_CACHE_DIR . 'we_cache_' . $entry) . '" AND Date<NOW()') ?
			false :
			we_unserialize(we_base_file::load($file));
	}

	public static function save($entry, array $data, $expiry = 3600, $serializer = SERIALIZE_PHP){
		$ser = we_serialize($data, $serializer); //keep this php, since encoding etc. works better & faster in all modes
		we_base_file::save(WE_CACHE_PATH . 'we_cache_' . $entry, (strlen($ser) > 1024 ? gzcompress($ser, 6) : $ser));
		if($expiry > 0){
			we_base_file::insertIntoCleanUp(WE_CACHE_DIR . 'we_cache_' . $entry, $expiry);
		}
	}

	public static function touch($entry, $expiry = 3600){
		if($expiry > 0){
			we_base_file::insertIntoCleanUp(WE_CACHE_DIR . 'we_cache_' . $entry, $expiry);
		}
	}

	public static function clean($pattern = ''){
		$files = [];
		foreach(glob(WE_CACHE_PATH . 'we_cache_' . $pattern . '*') as $file){
			unlink($file);
			$files[] = $GLOBALS['DB_WE']->escape($file);
		}
		if($files){
			$GLOBALS['DB_WE']->query('DELETE FROM ' . CLEAN_UP_TABLE . ' WHERE Path IN ("' . implode('","', $files) . '")');
		}
	}

}
