<?php

/**
 * webEdition CMS
 *
 * $Rev: 14873 $
 * $Author: mokraemer $
 * $Date: 2018-02-10 20:28:44 +0100 (Sat, 10 Feb 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_editor_base{
	protected $jsCmd = null;

	/**
	 * @var null|we_contents_root
	 */
	protected $we_doc = null;
	protected $charset = '';
	protected $title = '';

	public function __construct(we_contents_root $we_doc, we_base_jsCmd $jsCmd = null, $we_transaction = ''){
		$this->jsCmd = $jsCmd ?: new we_base_jsCmd();
		$this->we_doc = $we_doc;
	}

	public function getJsCmd(){
		return $this->jsCmd;
	}

	public abstract function show();

	/**
	 *
	 * @param string $form
	 * @param string $header
	 * @param array  $bodyAttr
	 * @param array $formAttr set to false if no form should be generated,else set form attributes
	 * @return string
	 */
	protected function getPage($form, $header = '', $bodyAttr = [], $formAttr = []){
		return we_html_tools::getHtmlTop($this->title, $this->charset, '', $header .
				we_html_element::jsScript(JS_DIR . 'multiIconBox.js') .
				we_editor_script::get() .
				$this->jsCmd->getCmds(), we_html_element::body(array_merge(
						[
					'class' => 'weEditorBody',
					'onunload' => "doUnload()"
						], $bodyAttr), ($formAttr === false ?
					$form :
					we_html_element::form(array_merge([
						'name' => 'we_form',
						'method' => 'post',
						'onsubmit' => 'return false;'
							], $formAttr), we_contents_base::hiddenTrans() .
						$form .
						we_html_element::hidden("we_complete_request", 1)))
				)
		);
	}

}
