<?php

/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_rpcCmd_doclistGetSearchResult extends we_rpc_cmd{

	function execute(){

		$resp = new we_rpc_response();

		we_html_tools::protect();

		if(($trans = we_base_request::_(we_base_request::TRANSACTION, 'we_transaction', 0))){
			$we_dt = isset($_SESSION['weS']['we_data'][$trans]) ? $_SESSION['weS']['we_data'][$trans] : '';
		}
		$ct = $we_dt[0]['ContentType'];
		$document = we_base_ContentTypes::getObject($ct);
		$document->we_initSessDat($we_dt);

		$dm = $document->getDoclistModel();
		$doclistView = new we_doclist_view($dm);
		$doclistSearch = $doclistView->searchclass;
		$results = $doclistSearch->searchProperties($doclistView->Model);

		// tabListContent() should know view!!
		$code = $doclistView->tabListContent($dm->getProperty('currentSetView'), $doclistView->makeContent($results), 'middlefont', we_search_view::SEARCH_DOCLIST);
		$resp->setData('data', $code);

		return $resp;
	}

}
