<?php
/**
 * webEdition CMS
 *
 * $Rev: 14885 $
 * $Author: mokraemer $
 * $Date: 2018-02-12 14:22:05 +0100 (Mon, 12 Feb 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
we_modules_info::isActive(we_modules_info::USERS);
define('LIVEUPDATE_DIR', $_SERVER['DOCUMENT_ROOT'] . '/webEdition/liveUpdate/');

class we_rpcCmd_usersPing extends we_rpc_cmd{

	function execute(){
		$resp = new we_rpc_response();
		$LUActive = is_dir(LIVEUPDATE_DIR . 'updateClient') && is_readable(LIVEUPDATE_DIR . 'updateClient');

		$relRequest = we_users_user::updateActiveUser($LUActive);
		if($relRequest){
			$resp->setData('release', $relRequest);
		}
		if($LUActive){
			return $resp;
		}

		list($num, $usr) = we_users_online::getUsers();

		$resp->setData('users', $usr);
		$resp->setData('num_users', $num);

		$aDat = we_unserialize(we_base_preferences::getUserPref('cockpit_dat')); // array as saved in the prefs
		foreach($aDat as $d){
			if($d){
				foreach($d as $aProps){
					if($aProps[0] === 'mfd'){
						$widget = new we_widget_mfd('', $aProps);
						$resp->setData('mfd_data', $widget->getLastModified());
					}
				}
			}
		}
		return $resp;
	}

	public function cleanUp(){
		we_base_file::cleanTempFiles();
	}

}
