<?php

/**
 * webEdition CMS
 *
 * $Rev: 14995 $
 * $Author: mokraemer $
 * $Date: 2018-03-05 14:42:14 +0100 (Mon, 05 Mar 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_tagData_selectAttribute extends we_tagData_attribute{
	/**
	 * @var array
	 */
	protected $Options;

	/**
	 * @param string $name
	 * @param array $options
	 * @param boolean $required
	 */
	function __construct($name, $options = [], $required = false, $module = '', $description = '', $deprecated = false){
		if(!is_array($options)){
			return;
		}
		parent::__construct($name, $required, $module, $description, $deprecated);
		$this->Options = parent::getUseOptions($options);
	}

	static function getTrueFalse($reverse = false){
		static $tmp = false;
		if(!$tmp){
			$tmp = [new we_tagData_option('true'), new we_tagData_option('false')];
		}
		return $reverse ? array_reverse($tmp) : $tmp;
	}

	/**
	 * @return string
	 */
	function getCodeForTagWizard(){
		$select = new we_html_select(['name' => $this->getName(), 'id' => $this->getIdName(), 'class' => 'defaultfont selectinput']);
		if(!$this->Required){
			$select->addOption('', '');
		}

		foreach($this->Options as $option){
			$select->addOption($option->Value, $option->getName(), $option->Disabled ? ['disabled' => 'disabled'] : []);
		}
		$select->selectOption($this->Value);

		return '<table class="attribute"><tr>
						<td class="attributeName">' . $this->getLabelCodeForTagWizard() . '</td>
						<td class="attributeField">' . $select->getHtml() . '</td>
					</tr></table>';
	}

}

//FIXME: remove
class weTagData_selectAttribute extends we_tagData_selectAttribute{

}
