<?php
/**
 * webEdition CMS
 *
 * $Rev: 14853 $
 * $Author: mokraemer $
 * $Date: 2018-02-07 21:28:53 +0100 (Wed, 07 Feb 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
we_html_tools::protect();

$uniqid = md5(uniqid(__FILE__, true)); // #6590, changed from: uniqid(time())

$we_transaction = we_base_request::_(we_base_request::TRANSACTION, 'we_cmd', '', 1);

// init document
$we_dt = isset($_SESSION['weS']['we_data'][$we_transaction]) ? $_SESSION['weS']['we_data'][$we_transaction] : [];
$we_doc = we_document::initDoc($we_dt);


if(!($we_doc instanceof we_imageDocument)){
	exit("ERROR: Couldn't initialize we_imageDocument object");
}

function getSelectorHTML(we_imageDocument $we_doc, &$selectedID){
	global $DB_WE;
// SELECT Box with thumbnails
	$thumbnails = new we_html_select(['multiple' => 'multiple', 'name' => "Thumbnails", 'id' => "Thumbnails", 'class' => 'defaultfont', "size" => 6, 'style' => "width: 340px;",
		'onchange' => "select_thumbnails(this);"]);
	$DB_WE->query('SELECT ID,Text,Format,description FROM ' . THUMBNAILS_TABLE . ' ORDER BY Text');

	$doc_thumbs = ($we_doc->Thumbs == -1) ? [] : explode(',', $we_doc->Thumbs);

	$thumbnail_counter_firsttime = true;
	while($DB_WE->next_record()){
		if(!in_array($DB_WE->f('ID'), $doc_thumbs)){
			if(we_base_imageEdit::is_imagetype_read_supported(we_base_imageEdit::$GDIMAGE_TYPE[strtolower($we_doc->Extension)]) && we_base_imageEdit::is_imagetype_supported(trim($DB_WE->f('Format')) ?: we_base_imageEdit::$GDIMAGE_TYPE[strtolower($we_doc->Extension)])){
				$thumbnails->addOption($DB_WE->f('ID'), $DB_WE->f('Text'));
			}
			if($thumbnail_counter_firsttime){
				$selectedID = $DB_WE->f('ID');
				$thumbnails->selectOption($selectedID);
			}

			$thumbnail_counter_firsttime = false;
		}
	}
	return $thumbnails->getHtml();
}

$selectedID = 0;
$parts = [
	['headline' => '',
		'html' => getSelectorHTML($we_doc, $selectedID) . '<p style="text-align:right">' . we_html_button::create_button('edit_all_thumbs', "javascript:we_cmd('editThumbs','top.opener.location=top.opener.location;');", false) . '</p>'],
	['headline' => '',
		'html' => '<iframe name="showthumbs" id="showthumbs" src="' . WEBEDITION_DIR . 'showThumb.php?u=' . $uniqid . '&t=' . $we_transaction . '&id=' . $selectedID . '" style="width:340px;height:130px;"></iframe>']
];

echo we_html_tools::getHtmlTop(g_l('weClass', '[thumbnails]'), '', '', we_html_element::jsScript(JS_DIR . 'add_thumb.js', '', ['id' => 'loadVarAdd_thumb', 'data-thumbData' => setDynamicVar([
			'transaction' => $we_transaction
	])]), we_html_element::body(['class' => 'weDialogBody', 'onload' => "top.focus();"], we_html_multiIconBox::getHTML('', $parts, true, we_html_button::position_yes_no_cancel(we_html_button::create_button(we_html_button::OK, "javascript:add_thumbnails();", '', "", !$selectedID, false), null, we_html_button::create_button(we_html_button::CANCEL, "javascript:top.close();")), -1, "", "", false, g_l('weClass', '[thumbnails]'))));
