<?php
/**
 * webEdition CMS
 *
 * $Rev: 14853 $
 * $Author: mokraemer $
 * $Date: 2018-02-07 21:28:53 +0100 (Wed, 07 Feb 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
we_html_tools::protect([we_base_perm::ADMINISTRATOR]);

if(we_base_request::_(we_base_request::BOOL, 'clearlog')){
	$GLOBALS['DB_WE']->query('DELETE FROM ' . FORMMAIL_LOG_TABLE);
}

function getContent(){
	$headline = [
		we_html_element::b(g_l('prefs', '[ip_address]')),
		we_html_element::b(g_l('liveUpdate', '[updatelog][date]'))
	];

	$content = [];

	$count = 15;
	$start = max(we_base_request::_(we_base_request::INT, 'start', 0), 0);

	$nextprev = "";

	$num_all = f('SELECT COUNT(1) FROM ' . FORMMAIL_LOG_TABLE);

	$GLOBALS['DB_WE']->query('SELECT ip,DATE_FORMAT(unixTime,"' . g_l('weEditorInfo', '[mysql_date_format]') . '") AS unixTime FROM ' . FORMMAIL_LOG_TABLE . ' ORDER BY unixTime DESC LIMIT ' . abs($start) . ',' . abs($count));
	$num_rows = $GLOBALS['DB_WE']->num_rows();
	if($num_rows > 0){
		while($GLOBALS['DB_WE']->next_record()){
			$content[] = [
				['dat' => $GLOBALS['DB_WE']->f('ip')],
				['dat' => $GLOBALS['DB_WE']->f('unixTime')]
			];
		}

		$next = $start + $count;

		$nextprev = '<table style="margin-top: 10px;" class="default"><tr><td style="padding-right:20px;">' .
			($start > 0 ?
			we_html_button::create_button(we_html_button::BACK, WEBEDITION_DIR . "we_cmd.php?we_cmd[0]=show_formmail_log&start=" . ($start - $count)) : //bt_back
			we_html_button::create_button(we_html_button::BACK, "", '', "", true)
			) .
			'</td><td class="defaultfont bold" style="width:120px;text-align:center;padding-right:20px;">' . ($start + 1) . "&nbsp;-&nbsp;" .
			min($num_all, $start + $count) .
			"&nbsp;" . g_l('global', '[from]') . " " . ($num_all) . '</td><td>' .
			($next < $num_all ?
			we_html_button::create_button(we_html_button::NEXT, WEBEDITION_DIR . "we_cmd.php?we_cmd[0]=show_formmail_log&start=" . $next) : //bt_next
			we_html_button::create_button(we_html_button::NEXT, "", "", "", true)
			) .
			"</td></tr></table>";

		return [
			['headline' => '',
				'html' => we_html_tools::dialogBorder(730, $content, $headline) . $nextprev,
				'noline' => true
			]
		];
	}
	return [
		['headline' => '',
			'html' => we_html_element::span(['class' => 'middlefont lowContrast'], g_l('prefs', '[log_is_empty]')) .
			we_html_element::br() .
			we_html_element::br(),
			'noline' => true
		]
	];
}

echo we_html_tools::getHtmlTop(g_l('prefs', '[formmail_log]'), '', '', we_html_element::jsScript(JS_DIR . 'formmaillog.js'), we_html_element::body(['class' => 'weDialogBody',
		'onload' => 'self.focus();'], we_html_multiIconBox::getHTML('show_log_data', getContent(), true, we_html_button::formatButtons(we_html_button::create_button(we_html_button::REFRESH, "javascript:location.reload();") . we_html_button::create_button(we_html_button::CLOSE, "javascript:self.close();") . we_html_button::create_button(we_html_button::LOG_CLEAR, "javascript:clearLog()")), -1, '', '', false, g_l('prefs', '[formmail_log]'))
));
