<?php

/**
 * webEdition CMS
 *
 * $Rev: 14853 $
 * $Author: mokraemer $
 * $Date: 2018-02-07 21:28:53 +0100 (Wed, 07 Feb 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_glossary_settingFrames{
	private $Frameset;
	var $Controller;
	var $db;

	function __construct(){
		$this->Frameset = WE_MODULES_DIR . 'glossary/edit_glossary_settings_frameset.php';
		$this->Controller = new we_glossary_settingControl();
		$this->db = new DB_WE();
	}

	function getHTML($what){
		switch($what){
			case 'frameset':
				echo $this->getHTMLFrameset();
				break;
			default:
				t_e(__FILE__ . " unknown reference: $what");
		}
	}

	function getHTMLFrameset(){
		return
			we_html_tools::getHtmlTop('', '', '', we_html_element::jsScript(JS_DIR . 'formFunctions.js'), we_html_element::body(['class' => 'weDialogBody']
					, we_html_element::exIFrame('content', $this->getHTMLContent(), 'position:absolute;top:0;bottom:1px;left:0;right:0;overflow: hidden;') .
					we_html_element::iframe('cmdFrame', 'about:blank', 'position:absolute;height:1px;bottom:0;left:0;right:0;overflow: hidden;')
		));
	}

	function getHTMLContent(){
		// Automatic Replacement
		$content = we_html_forms::checkboxWithHidden(we_glossary_replace::useAutomatic(), 'GlossaryAutomaticReplacement', g_l('modules_glossary', '[enable_replacement]'));

		$parts = [['headline' => '',
			'html' => $content,
			'noline' => true]
		];

		return
			'<form name="we_form" target="cmdFrame" action="' . $this->Frameset . '">
	' . we_html_element::hidden('cmd', 'save_glossary_setting') . '
	' . we_html_multiIconBox::getHTML('GlossaryPreferences', $parts, true, we_html_button::position_yes_no_cancel(
					we_html_button::create_button(we_html_button::SAVE, 'javascript:document.we_form.submit();'), null, we_html_button::create_button(we_html_button::CLOSE, 'javascript:top.window.close();')), -1, '', '', false, g_l('modules_glossary', '[menu_settings]')) . '
	</form>';
	}

}
