<?php

/**
 * webEdition CMS
 *
 * $Rev: 15028 $
 * $Author: mokraemer $
 * $Date: 2018-03-10 12:27:18 +0100 (Sat, 10 Mar 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
function we_parse_tag_customer($attribs, $content, array $arr){
	$name = weTag_getParserAttribute('name', $arr);
	if($name && strpos($name, ' ') !== false){
		return parseError(sprintf(g_l('parser', '[name_with_space]'), 'customer'));
	}

	return '<?php ' . (strpos($content, '$lv') !== false ? 'global $lv;' : '') .
		'if(' . we_tag_tagParser::printTag('customer', $attribs) . '){?>' . $content . '<?php }
		we_post_tag_listview(); ?>';
}

function we_tag_customer(array $attribs){
	if(!we_modules_info::isActive(we_modules_info::CUSTOMER)){
		echo modulFehltError('Customer', __FUNCTION__);
		return false;
	}

	$condition = weTag_getAttribute('condition', $attribs, 0, we_base_request::RAW);
	$we_cid = weTag_getAttribute('id', $attribs, 0, we_base_request::INT);
	$name = weTag_getAttribute('name', $attribs, '', we_base_request::STRING);
	$showName = weTag_getAttribute('_name_orig', $attribs, '', we_base_request::STRING);
	$hidedirindex = weTag_getAttribute('hidedirindex', $attribs, TAGLINKS_DIRECTORYINDEX_HIDE, we_base_request::BOOL);

	if($name){
		if(strpos($name, ' ') !== false){
			echo parseError(sprintf(g_l('parser', '[name_with_space]'), 'object'));
			return false;
		}

		$we_doc = $GLOBALS['we_doc'];
		$we_cid = intval(($we_doc->getElement($name, we_contents_base::ETYPE_NUMBER) ?
			$we_doc->getElement($name, we_contents_base::ETYPE_NUMBER) :
			($we_doc->getElement($name) ?
			$we_doc->getElement($name) :
			$we_cid)
		));

		$we_cid = $we_cid ?: we_base_request::_(we_base_request::INT, 'we_cid', 0);
		$path = f('SELECT Username FROM ' . CUSTOMER_TABLE . ' WHERE ID=' . $we_cid);
		$textname = 'we_' . $GLOBALS['we_doc']->Name . '_customer[' . $name . '_path]';
		$idname = 'we_' . $GLOBALS['we_doc']->Name . '_customer[' . $name . '#' . we_contents_base::ETYPE_NUMBER . ']';

		if($GLOBALS['we_editmode']){
			?>
			<table class="weEditTable">
				<tr>
					<td><?= $showName; ?></td>
					<td><?= we_html_element::hidden($idname, $we_cid) ?></td>
					<td><?= we_html_tools::textInput($textname, $path, '', ['readonly' => 'readonly'], 'text', 0, 0); ?></td>
					<td><?= we_html_button::create_button(we_html_button::SELECT, "javascript:we_cmd('we_customer_selector',document.forms[0].elements." . $idname . ".value,WE().consts.tables.CUSTOMER_TABLE,'" . $idname . "','" . $textname . ",'reload_editpage');opener._EditorFrame.setEditorIsHot(true);','',0,'',1)"); ?></td>
					<td><?= we_html_button::create_button(we_html_button::TRASH, "javascript:document.forms[0].elements." . $idname . ".value=0;document.forms[0].elements['" . $textname . "'].value='';_EditorFrame.setEditorIsHot(false);we_cmd('reload_editpage');"); ?></td>
				</tr>
			</table><?php
		}
	} else {
		$we_cid = $we_cid ?: we_base_request::_(we_base_request::INT, 'we_cid', 0);
	}

	$lv = new we_listview_customer('', 1, 0, '', 0, 'ID=' . intval($we_cid) . ($condition ? ' AND ' . $condition : ''), '', 0, $hidedirindex);
	we_pre_tag_listview($lv);

	$avail = $lv->next_record();
	if($avail){
//implement seem
	}
	return $avail;
}
