<?php

/**
 * webEdition CMS
 *
 * $Rev: 14628 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 12:39:29 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
function _we_tag_ifUser_setUserGroups($parent){
	while($parent){
		$_SESSION['user']['Groups'][] = $parent;
		$parent = f('SELECT ParentID FROM ' . USER_TABLE . ' WHERE ID=' . $parent);
	}
}

function we_tag_ifUser($attribs = []){
	if(empty($GLOBALS['we_editmode']) || empty($_SESSION['user'])){
		//if not editmode or in frontend, show content
		return !weTag_getAttribute('not', $attribs, false, we_base_request::BOOL);
	}

	if(weTag_getAttribute('admin', $attribs, false, we_base_request::BOOL) && we_base_permission::hasPerm('ADMINISTRATOR')){
		return true;
	}
	$user = weTag_getAttribute('user', $attribs, [], we_base_request::INTLISTA);
	$group = weTag_getAttribute('group', $attribs, [], we_base_request::INTLISTA);
	$recurse = weTag_getAttribute('recursive', $attribs, false, we_base_request::BOOL);

	$ret = ($user ? in_array($_SESSION['user']['ID'], $user) : false);

	if($group){
		if($recurse && empty($_SESSION['user']['Groups'])){
			_we_tag_ifUser_setUserGroups($_SESSION['user']['Group']);
			$_SESSION['user']['Groups'] = [];
			foreach($_SESSION['user']['Aliases'] as $parent){
				_we_tag_ifUser_setUserGroups($parent);
			}
		}
		$ret |= ($recurse ? !empty(array_intersect($group, $_SESSION['user']['Groups'])) : in_array($_SESSION['user']['Group'], $group));
	}

	return $ret;
}
