<?php

/**
 * webEdition CMS
 *
 * $Rev: 14956 $
 * $Author: mokraemer $
 * $Date: 2018-02-27 11:38:55 +0100 (Tue, 27 Feb 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
function we_tag_ifVarEmpty(array $attribs){
	$name = weTag_getAttribute('name', $attribs, '', we_base_request::STRING);
	$orgName = weTag_getAttribute('_name_orig', $attribs, '', we_base_request::STRING);

	if(!$name){
		$attribs['_name_orig'] = $orgName = weTag_getAttribute('match', $attribs, '', we_base_request::STRING);
		$attribs['name'] = $name = we_tag_getPostName($orgName);

	}

	if(!$orgName && ($foo = attributFehltError($attribs, 'name', __FUNCTION__))){
		echo $foo;
		return false;
	}
	$type = weTag_getAttribute('type', $attribs, '', we_base_request::STRING);

	switch($type){
		case 'request' :
			$ret = getArrayValue($_REQUEST, null, $orgName);
			return empty($ret);
		case 'post' :
			$ret = getArrayValue($_POST, null, $orgName);
			return empty($ret);
		case 'get' :
			$ret = getArrayValue($_GET, null, $orgName);
			return empty($ret);
		case 'global' :
			$ret = getArrayValue($GLOBALS, null, $orgName);
			return empty($ret);
		case 'session' :
			$ret = getArrayValue($_SESSION, null, $orgName);
			return empty($ret);
		case 'sessionfield' :
			return empty($_SESSION['webuser'][$orgName]);
	}

	$docAttr = weTag_getAttribute('doc', $attribs, '', we_base_request::STRING);
	switch($docAttr){
		case 'object' :
		case 'document' :
			$formname = weTag_getAttribute('formname', $attribs, 'we_global_form', we_base_request::STRING);
			$doc = isset($GLOBALS['we_' . $docAttr][$formname]) ? $GLOBALS['we_' . $docAttr][$formname] : false;
			break;
		case 'top' :
			$doc = isset($GLOBALS['WE_MAIN_DOC']) ? $GLOBALS['WE_MAIN_DOC'] : false;
			break;
		default :
			$doc = isset($GLOBALS['we_doc']) ? $GLOBALS['we_doc'] : false;
	}
	if(!$doc){
		return true;
	}

	if(weTag_getAttribute('property', $attribs, false, we_base_request::BOOL)){
		return empty($doc->$orgName);
	}

	$type = $type ?: $doc->getElement($orgName, 'type');
	switch($type){
		case 'href' :
			$foo = $doc->getField($attribs, $type, true);
			return empty($foo) || $foo === '/';
		case 'multiobject':
			//FIXME: this makes no sense
			/* $attribs['name'] = $name;
			  $attribs['_name_orig'] = $orgName; */
			$data = we_unserialize($doc->getField($attribs, $type, true));
			$objects = isset($data['objects']) ? $data['objects'] : $data;
			return empty($objects);
		default :
			$elemType = $doc->getElement($name, 'type');
			$foo = $doc->getElement($name, $elemType === 'img' ? we_contents_base::ETYPE_NUMBER : we_contents_base::ETYPE_UNKNOWN);

			if(!$foo){
				$elemType = $doc->getElement($orgName, 'type');
				$foo = $doc->getElement($orgName, $elemType === 'img' ? we_contents_base::ETYPE_NUMBER : we_contents_base::ETYPE_UNKNOWN);
			}
			return empty($foo);
	}
}
