<?php

/**
 * webEdition CMS
 *
 * $Rev: 14900 $
 * $Author: mokraemer $
 * $Date: 2018-02-13 01:21:30 +0100 (Tue, 13 Feb 2018) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
function we_tag_js(array $attribs){
	if(($foo = attributFehltError($attribs, 'id', __FUNCTION__))){
		return $foo;
	}
	$src = f('SELECT CONCAT(Path,"?m=",Published) FROM ' . FILE_TABLE . ' WHERE ID=' . weTag_getAttribute('id', $attribs, 0, we_base_request::INT));

	if(!$src){
		return '';
	}

	$rel = weTag_getAttribute('rel', $attribs, '', we_base_request::STRING);
	if($rel === 'preload'){
		$attribs['as'] = 'script';
		header('Link: <' . $src . '>; rel=preload; as=script', false);
	}

	$attribs['src'] = $src;

	//	prepare $attribs for output:
	return getHtmlTag('script', removeAttribs($attribs, ['id']), '', true) . "\n";
}
