<?php

/**
 * webEdition CMS
 *
 * $Rev: 14633 $
 * $Author: mokraemer $
 * $Date: 2017-12-04 14:37:38 +0100 (Mon, 04 Dec 2017) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
require_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we.inc.php');
we_html_tools::protect();
$mod = we_base_request::_(we_base_request::STRING, 'mod');

if(strpos($mod, '?')){//FIXME:remove
	t_e('error in mod-request', $mod);
	//compatibility code for ?mod=xxx?pnt=yy
	list($mod, $other) = explode('?', $mod);
	$_REQUEST['mod'] = $mod;
	list($k, $v) = explode('=', $other);
	$_REQUEST[$k] = $v;
}

if(!we_modules_info::isActive($mod)){
	return;
}

$what = we_base_request::_(we_base_request::STRING, 'pnt', 'frameset');
$mode = we_base_request::_(we_base_request::INT, 'art', 0);
$step = we_base_request::_(we_base_request::INT, 'step', 0);

if($what === 'show_frameset'){ //old call to show_frameset.php
	$_REQUEST['mod'] = $mod = (isset($mod) ? $mod : we_base_request::_(we_base_request::STRING, 'mod'));

	//TODO: we should loop through all we_cmd and process them in respective we_module_frames.class only
	$cmd1 = we_base_request::_(we_base_request::INT, 'we_cmd', false, 1); //to be used only for IDs or integer constants!
	$sid = $mod === we_modules_info::CUSTOMER && $cmd1 !== false ? $cmd1 : we_base_request::_(we_base_request::RAW, 'sid');
	$bid = $mod === we_modules_info::SHOP && $cmd1 !== false ? $cmd1 : we_base_request::_(we_base_request::RAW, 'bid');
	//FIXME: this is nonsense
	switch($mod){
		case we_modules_info::SEARCH:
			unset($_SESSION['weS']['weSearch_session']);
			switch(($cmd2 = we_base_request::_(we_base_request::TABLE, 'we_cmd', '', 2))){//FIXME: bad to have different types at one query
				case FILE_TABLE:
					$_SESSION['weS']['weSearch']['checkWhich'] = 1;
					$cmd = 'weSearch_new_forDocuments';
					break;
				case TEMPLATES_TABLE:
					$_SESSION['weS']['weSearch']['checkWhich'] = 2;
					$cmd = 'weSearch_new_forTemplates';
					break;
				case OBJECT_FILES_TABLE :
					$_SESSION['weS']['weSearch']['checkWhich'] = 3;
					$cmd = 'weSearch_new_forObjects';
					break;
				case OBJECT_TABLE :
					$_SESSION['weS']['weSearch']['checkWhich'] = 4;
					$cmd = 'weSearch_new_forClasses';
					break;
				default:
					$cmd = 'weSearch_new';
			}
			$searchInitParams = '&' . http_build_query([
						'cmd' => $cmd,
						'keyword' => we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1),
						'we_cmd' => we_base_request::_(we_base_request::STRING, 'we_cmd'),
						'modelid' => we_base_request::_(we_base_request::INT, 'we_cmd', 0, 3),
						'tab' => we_base_request::_(we_base_request::INT, 'we_cmd', 0, 4),
			]);
			break;
		default:
			$searchInitParams = '';
	}

	$we_tabs = new we_gui_tabs();

	foreach(we_modules_info::showModuleInMenu('', 'inModuleMenu') as $menuItem){
		if(we_users_util::canEditModule($menuItem['name'])){
			$we_tabs->addTab($menuItem['text_short'], ($menuItem['icon'] ?: ''), ( $mod == $menuItem['name']), "'" . $menuItem['name'] . "'", ['id' => $menuItem['name']]);
		}
	}
	echo we_html_tools::getHtmlTop('', '', '', we_html_element::cssLink(CSS_DIR . 'we_tab.css') .
			we_html_element::jsScript(WE_JS_MODULES_DIR . 'showMod.js', '', ['id' => 'loadVarShowMod', 'data-moduleData' => setDynamicVar([
					'mod' => $mod,
		])]) . JQUERY, we_html_element::body(['id' => "weMainBody", 'onload' => "weTabs.setFrameSize()", 'onresize' => "weTabs.setFrameSize()"], '<dialog id="alertBox"></dialog>' .
					we_html_element::div(['style' => 'right:0;', 'name' => 'naviDiv', 'id' => 'naviDiv'], '<div id="main" >' . $we_tabs->getHTML() . '</div>') .
					we_html_element::iframe('content', WEBEDITION_DIR . 'we_showMod.php?mod=' . $mod . $searchInitParams . ($cmd1 === false ? '' : '&msg_param=' . $cmd1) . ($sid !== false ? '&sid=' . $sid : '') . ($bid !== false ? '&bid=' . $bid : ''), ' ', '', '', false)
			)
	);

	return;
}

switch($mod){
	case we_modules_info::WORKFLOW:
		$override = ($what === 'log');
	default:
		$protect = we_modules_info::isActive($mod) && (we_users_util::canEditModule($mod) || !empty($override)) ? [] : [false];
		we_html_tools::protect($protect);
}

switch($mod){
	case we_modules_info::BANNER:
		$weFrame = new we_banner_frames(WEBEDITION_DIR . 'we_showMod.php?mod=' . $mod);
		$weFrame->process();
		break;
	case we_modules_info::SEARCH:
		$weFrame = new we_search_frames();
		$weFrame->process();
		break;
	case we_modules_info::SHOP:
		$weFrame = new we_shop_frames(WEBEDITION_DIR . 'we_showMod.php?mod=' . $mod);
		$weFrame->View->processCommands($weFrame->jsCmd);
		break;
	case we_modules_info::CUSTOMER:
		switch($what){
			case 'export':
			case 'eibody':
			case 'eifooter':
			case 'eiload':
			case 'import':
			case 'eiupload':
				$mode = we_base_request::_(we_base_request::STRING, "art", 0);
				$weFrame = new we_customer_EIWizard(WEBEDITION_DIR . 'we_showMod.php?mod=' . $mod);
				break;
			default:
				$weFrame = new we_customer_frames(WEBEDITION_DIR . 'we_showMod.php?mod=' . $mod);
				$weFrame->process();
		}
		break;
	case we_modules_info::USERS:
		$weFrame = new we_users_frames(WEBEDITION_DIR . 'we_showMod.php?mod=' . $mod);
		$weFrame->process();
		break;

	case we_modules_info::EXPORT:
		$weFrame = new we_export_frames(WEBEDITION_DIR . 'we_showMod.php?mod=' . $mod);
		$weFrame->process();
		break;

	case we_modules_info::GLOSSARY:
		$weFrame = new we_glossary_frames(WEBEDITION_DIR . 'we_showMod.php?mod=' . $mod);
		$weFrame->process();
		break;

	case we_modules_info::VOTING:
		$weFrame = new we_voting_frames(WEBEDITION_DIR . 'we_showMod.php?mod=' . $mod);
		$weFrame->process();
		break;

	case we_modules_info::DOCTYPE:
		$weFrame = new we_doctype_frames(WEBEDITION_DIR . 'we_showMod.php?mod=' . $mod);
		$weFrame->process();
		break;

	case we_modules_info::THUMB:
		$weFrame = new we_thumbnail_frames(WEBEDITION_DIR . 'we_showMod.php?mod=' . $mod);
		$weFrame->process();
		break;

	case we_modules_info::CATEGORY:
		$weFrame = new we_category_frames(WEBEDITION_DIR . 'we_showMod.php?mod=' . $mod);
		$weFrame->process();
		break;

	case we_modules_info::NAVIGATION:
		switch($what){
			case 'ruleCmd':
			case 'ruleContent':
			case 'ruleFrameset':
				we_html_tools::protect([we_base_perm::NAVIAGTION_EDIT_RULES]);
				$weFrame = new we_navigation_ruleFrames();
				$weFrame->process($weFrame->jsCmd);
				break;
			default:
				$weFrame = new we_navigation_frames('');
				$weFrame->process();
				break;
		}
		break;

	case we_modules_info::WORKFLOW:
		$type = we_base_request::_(we_base_request::INTLIST, 'type', 0);
		$weFrame = new we_workflow_frames(WEBEDITION_DIR . 'we_showMod.php?mod=' . $mod);
		$weFrame->process();
		echo $weFrame->getHTML($what, $mode, $type);
		return;

	case we_modules_info::NEWSLETTER:
		$ncmd = we_base_request::_(we_base_request::STRING, 'ncmd', '');

		$weFrame = new we_newsletter_frames(WEBEDITION_DIR . 'we_showMod.php?mod=' . $mod);
		switch($what){
			case 'edit_file':
				$mode = we_base_request::_(we_base_request::FILE, 'art');
				break;
			default:
				$mode = we_base_request::_(we_base_request::INT, 'art', 0);
				break;
		}

		if(($id = we_base_request::_(we_base_request::INT, 'inid')) !== false){
			$weFrame->View->Model = new we_newsletter_newsletter($id);
		} else {
			switch($what){
				case 'export_csv_mes':
				case 'newsletter_settings':
				case 'qsend':
				case 'eedit':
				case 'black_list':
				case 'upload_csv':
					break;
				default:
					$weFrame->View->processVariables();
			}
		}

		switch($what){
			case 'export_csv_mes':
			case 'preview':
			case 'domain_check':
			case 'newsletter_settings':
			case 'show_log':
			case 'print_lists':
			case 'qsend':
			case 'eedit':
			case 'black_list':
				break;
			default:
				$mode = isset($mode) ? $mode : we_base_request::_(we_base_request::INT, 'art', 0);
				ob_start();
				$weFrame->View->processCommands($weFrame->jsCmd);
				//FIXME: remove
				$extraJS = ob_get_clean();
				if($extraJS){
					t_e('bad js', $extraJS);
				}
		}

		break;
	default:
		echo 'no module';
		return;
}

//FIXME: process will generate js output without doctype
echo $weFrame->getHTML($what, $mode, $step);
